--Veins of the Earth
--Zireael 2013-2014

local Talents = require("engine.interface.ActorTalents")

newEntity{
    define_as = "BASE_NPC_GOOD",
    type = "magical_beast",
    body = { INVEN = 10 },
    ai = "dumb_talented_simple", ai_state = { talent_in=3, },
    stats = { str=10, dex=10, con=10, int=10, wis=10, cha=10, luc=10 },
    combat = { dam= {1,6} },
    alignment = "neutral good",
    faction = "good",
}

--Magic circle against evil; immunity to poison, charm, and compulsion; scent, wild empathy
--Spell-likes: detect evil at will, 1/day greater teleport, cure moderate wounds; 3/day cure light wounds
newEntity{ base = "BASE_NPC_GOOD",
    define_as = "BASE_NPC_UNICORN",
    image = "tiles/newtiles/unicorn.png",
    display = 'q', color=colors.WHITE,
    desc = [[A beautiful unicorn.]],
    stats = { str=20, dex=17, con=21, int=10, wis=21, cha=24, luc=18 },
    combat = { dam= {1,8} },
    name = "unicorn",
    level_range = {5, nil}, exp_worth = 900,
    rarity = 15,
    max_life = resolvers.rngavg(40,45),
    hit_die = 4,
    challenge = 3,
    infravision = 4,
    combat_natural = 5,
    skill_jump = 16,
    skill_listen = 5,
    skill_movesilently = 5,
    skill_spot = 5,
    skill_survival = 2,
--  movement_speed_bonus = 0.88,
    movement_speed = 1.88,
    combat_attackspeed = 1.88,
    alignment = "chaotic good",
    resolvers.talents{ [Talents.T_ALERTNESS]=1 },
}

--Scent; spell-likes: At will—detect good and detect evil within a 60-foot radius.
newEntity{ base = "BASE_NPC_GOOD",
    define_as = "BASE_NPC_PEGASUS",
    image = "tiles/pegasus.png",
    display = 'q', color=colors.WHITE,
    desc = [[A beautiful winged horse.]],
    stats = { str=18, dex=15, con=16, int=10, wis=13, cha=13, luc=12 },
    name = "pegasus",
    level_range = {5, 25}, exp_worth = 900,
    rarity = 15,
    max_life = resolvers.rngavg(30,35),
    hit_die = 4,
    challenge = 3,
    infravision = 4,
    combat_natural = 2,
    skill_diplomacy = 2,
    skill_listen = 7,
    skill_sensemotive = 7,
    skill_spot = 7,
    alignment = "chaotic good",
    fly = true,
--  movement_speed_bonus = 1,
    movement_speed = 2,
    combat_attackspeed = 2,
    resolvers.talents{ [Talents.T_IRON_WILL]=1 },
}

--Fly 60 ft.; magic circle against evil; pounce, rake 1d6, spells as Clr7; Blind-Fight
--Spell-likes: 2/day—greater invisibility (self only); 1/day—dimension door. 
newEntity{ base = "BASE_NPC_GOOD",
    define_as = "BASE_NPC_LAMMASU",
    image = "tiles/cat.png",
    display = 'c', color=colors.GOLD,
    desc = [[A creature with a lion's body and a humanoid head with an impressive headdress.]],
    stats = { str=23, dex=12, con=17, int=16, wis=17, cha=14, luc=12 },
    name = "lammasu",
    level_range = {10, 25}, exp_worth = 2400,
    rarity = 15,
    max_life = resolvers.rngavg(55,60),
    hit_die = 7,
    challenge = 8,
    infravision = 4,
    combat_natural = 9,
    skill_concentration = 10,
    skill_diplomacy = 2,
    skill_knowledge = 10,
    skill_listen = 10,
    skill_sensemotive = 10,
    skill_spot = 12,
    alignment = "lawful good",
    fly = true,
--  movement_speed_bonus = 1,
    movement_speed = 2,
    combat_attackspeed = 2,
    resolvers.talents{ [Talents.T_IRON_WILL]=1 },
}


--Faction fit based on World's Greatest Dungeon
newEntity{ base = "BASE_NPC_GOOD",
    define_as = "BASE_NPC_EAGLE",
    display = 'e', color=colors.YELLOW,
    desc = [[A proud eagle.]],
    stats = { str=18, dex=17, con=12, int=10, wis=14, cha=10, luc=12 },
    name = "giant eagle", color=colors.YELLOW,
    image = "tiles/eagle.png",
    level_range = {5, 15}, exp_worth = 900,
    rarity = 8,
    max_life = resolvers.rngavg(25,30),
    hit_die = 4,
    challenge = 3,
    combat_natural = 2,
    skill_listen = 2,
    skill_spot = 13,
    skill_survival = 1,
--  movement_speed_bonus = 1.66,
    movement_speed = 2.66,
    combat_attackspeed = 2.66,
    fly = true,
    alignment = "neutral good",
}

--Fly 80 ft.; pounce, rake 1d6
newEntity{ base = "BASE_NPC_GOOD",
    define_as = "BASE_NPC_GRIFFON",
    image = "tiles/griffon.png",
    display = 'B', color=colors.GOLD,
    desc = [[A cross between a lion and an eagle.]],
    stats = { str=18, dex=15, con=16, int=5, wis=13, cha=8, luc=12 },
    combat = { dam= {2,6} },
    name = "griffon",
    level_range = {10, 25}, exp_worth = 1200,
    rarity = 15,
    max_life = resolvers.rngavg(60,65),
    hit_die = 7,
    challenge = 4,
    infravision = 4,
    combat_natural = 5,
    skill_jump = 4,
    skill_listen = 5,
    skill_spot = 9,
    resolvers.talents{ [Talents.T_IRON_WILL]=1 },
    fly = true,
--  movement_speed_bonus = 1.33,
    movement_speed = 2.33,
    combat_attackspeed = 2.33,
}

--Fly 70 ft; 
newEntity{ base = "BASE_NPC_GOOD",
    define_as = "BASE_NPC_OWL_GIANT",
    image = "tiles/owl.png",
    display = 'b', color=colors.BROWN,
    desc = [[A giant owl.]],
    uncommon_desc = [[Giant owl young can be trained to accept a rider. Giant owl eggs thus demand exorbitant prices on the open market.]],
    common_desc = [[A giant owl can see extremely well by moonlight. They speak Sylvan and Common.]],
    base_desc = [[This massive night hunter is a giant owl, a noble creature as intelligent as a human. It can see in the dark.]],

    stats = { str=18, dex=17, con=12, int=10, wis=14, cha=10, luc=12 },
    name = "giant owl",
    level_range = {5, 25}, exp_worth = 1500,
    rarity = 15,
    max_life = resolvers.rngavg(25,30),
    hit_die = 4,
    --4 in Incursion, bumped!
    challenge = 5,
    infravision = 2,
    combat_natural = 2,
    skill_knowledge = 2,
    skill_listen = 15,
    skill_movesilently = 5,
    skill_spot = 8,
--  movement_speed_bonus = 1.33,
    movement_speed = 2.33,
    combat_attackspeed = 2.33,
    alignment = "neutral good",
    fly = true,
    resolvers.talents{ [Talents.T_ALERTNESS]=1 },
}
